package com.crm.pay.controller.pay;

import com.crm.pay.controller.base.BasePayCloseFunctionController;
import com.crm.pay.entity.callback.Pay3PayCallbackEntity;
import com.crm.pay.service.Pay3PayService;
import com.crm.rely.backend.core.constant.Constants;
import com.crm.rely.backend.core.constant.FeignClientAnnotation;
import com.crm.rely.backend.model.constant.PayConstants;
import com.crm.rely.backend.core.dto.base.BaseResultDto;
import com.crm.pay.dto.PayDto;
import com.crm.rely.backend.model.entity.custom.info.CustomInfoEntity;
import com.crm.rely.backend.model.entity.finance.deposit.FinanceDepositAddEntity;
import com.crm.pay.entity.FinanceDepositParameterEntity;
import com.crm.pay.entity.finance.withdraw.automatic.FinanceWithdrawInfoEntity;
import com.crm.pay.entity.finance.withdraw.automatic.FinanceWithdrawPay3payEntity;
import com.crm.rely.backend.core.exception.PayValidatedException;
import com.google.common.base.Strings;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.math.BigDecimal;

@RestController
@RequestMapping("/pay3pay")
public class Pay3PayController extends BasePayCloseFunctionController {

    @Autowired
    private Pay3PayService service;

    /**
     * 支付
     *
     * @param login  入金账号
     * @param amount 入金金额
     * @return 错误信息
     * @throws Exception
     */
    @RequestMapping("/pay/{login}/{amount}/{bankCode}")
    public BaseResultDto pay(@PathVariable("login") Long login,
                             @PathVariable("amount") BigDecimal amount,
                             @PathVariable("bankCode") String bankCode,
                             @RequestBody FinanceDepositParameterEntity entity, HttpServletRequest request,
                             CustomInfoEntity infoEntity) throws Exception {


        return payCall(login, amount, bankCode, 0, entity, infoEntity, request);
    }

    @RequestMapping("/pay/{login}/{amount}/{bankCode}/{activity}")
    public BaseResultDto pay(@PathVariable("login") Long login,
                             @PathVariable("amount") BigDecimal amount,
                             @PathVariable("bankCode") String bankCode,
                             @PathVariable("activity") int activity,
                             @RequestBody FinanceDepositParameterEntity entity, HttpServletRequest request,
                             CustomInfoEntity infoEntity) throws Exception {


        return payCall(login, amount, bankCode, activity, entity, infoEntity, request);
    }

    private BaseResultDto payCall(Long login,
                                  BigDecimal amount,
                                  String bankCode,
                                  int activity,
                                  FinanceDepositParameterEntity entity,
                             CustomInfoEntity infoEntity, HttpServletRequest request) throws Exception {
        validated(login, amount);

        FinanceDepositAddEntity financeDepositSaveEntity = getFinanceDepositSaveEntity(login, amount, bankCode,
                PayConstants.PAY3_PAY_KEY, activity, entity, request);

        String url = service.pay(financeDepositSaveEntity);
        PayDto payDto = new PayDto(1, url);
        return BaseResultDto.success(payDto);
    }

    /**
     * 异步回调
     *
     * @param callbackEntity 用于获取回调数据
     * @return 返回成功给第三方系统
     * @throws Exception
     */
//    @GetMapping(value = "/callback")
//    public void callbackGet(Pay3PayCallbackEntity callbackEntity, HttpServletResponse response) throws Exception {
//        service.callback(callbackEntity);
//        sendRedirect(response);
//    }
    @PostMapping(value = "/callback")
    public void callbackPost(@RequestBody Pay3PayCallbackEntity callbackEntity, HttpServletResponse response) throws Exception {
        service.callbackPost(callbackEntity);
        sendRedirect(response);
    }


    @PostMapping("/withdraw/info")
    @FeignClientAnnotation
    public BaseResultDto withdrawInfo(@RequestBody FinanceWithdrawInfoEntity entity) throws Exception {
        if (Strings.isNullOrEmpty(entity.getPayType())) {
            return BaseResultDto.error(Constants.INFO_NOT_FOUND);
        }
        return BaseResultDto.success(service.withdrawInfo(entity));
    }

    @PostMapping("/withdraw")
    @FeignClientAnnotation
    public BaseResultDto withdraw(@RequestBody FinanceWithdrawPay3payEntity entity) throws Exception {
        if (Strings.isNullOrEmpty(entity.getPayType())) {
            return BaseResultDto.error(Constants.INFO_NOT_FOUND);
        }
        String url = service.withdraw(entity);
        PayDto payDto = new PayDto(1, url);
        return BaseResultDto.success(payDto);
    }

    @GetMapping("/withdraw/callback")
    public void withdrawCallbackGet(Pay3PayCallbackEntity entity, HttpServletResponse response) throws Exception {
        service.withdrawCallbackGet(1, entity);

        sendRedirect(response);
    }

    @PostMapping("/withdraw/callback")
    public void withdrawCallbackPost(@RequestBody Pay3PayCallbackEntity entity, HttpServletResponse response) throws Exception {
        service.withdrawCallbackPost(1, entity);
        sendRedirect(response);
    }

    @GetMapping("/agent/withdraw/callback")
    public void agentWithdrawCallbackGet(@RequestBody Pay3PayCallbackEntity entity, HttpServletResponse response) throws Exception {
        service.withdrawCallbackGet(2, entity);
        sendRedirect(response);
    }

    @PostMapping("/agent/withdraw/callback")
    public void agentWithdrawCallbackPOST(@RequestBody Pay3PayCallbackEntity entity, HttpServletResponse response) throws Exception {
        service.withdrawCallbackPost(2, entity);
        sendRedirect(response);
    }

    /**
     * 同步页面 成功
     *
     * @param response 用于重定向页面
     * @throws IOException
     */
    @GetMapping(value = "/pickup")
    public void pickup(HttpServletResponse response) throws Exception, PayValidatedException {

        sendRedirect(response);
    }

    @GetMapping(value = "/error")
    public void error(HttpServletResponse response) throws Exception {

        sendRedirect(response);
    }

}
